//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OutClock8.h"
#include "OutClock1.h"
///#include "OutClock5.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OverbyteIcsMimeDec"
#pragma link "OverbyteIcsPop3Prot"
///#pragma link "AbArcTyp"
///#pragma link "AbUnzPrc"
#pragma link "ZipForge"
#pragma resource "*.dfm"
TForm8 *Form8;

extern bool FlagSuppr;
int nbOctet;
TMimeDecode *MimeDecode1;
TListItem *pItem1;
TSslPop3Cli *IDPop3;
TMemoryStream *MemoryStream1, *MStream;
//---------------------------------------------------------------------------
__fastcall TForm8::TForm8(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Activate
void __fastcall TForm8::FormActivate(TObject *Sender)
{
DEBUG_LINE
	try  // 04/04/2004
	{
		ActiveControl = BoutonAnalyser;
	}
	catch(...) {;}
//  FlagSuppr = true; // voir...
	StatusBar1->SimpleText = "";
	ListView1->Items->Clear();
	pItem1 = Form1->ListView1->Items->Item[Form1->ListView1->Selected->Index];
	IDPop3 = (TSslPop3Cli*)pItem1->Data;
	LblExpediteur->Caption = pItem1->SubItems->Strings[0];
	LblSujet->Caption = pItem1->SubItems->Strings[1];
	LblTaille->Caption = pItem1->SubItems->Strings[3];
	if (BoutonAnalyser->Tag) // 26/04/2005 positionn par Form3->BtnAnalyser
	{
		BoutonAnalyser->Tag = 0;
		BoutonAnalyserClick(Sender);
	}
}
//---------------------------------------------------------------------------
// Bouton Analyser
void __fastcall TForm8::BoutonAnalyserClick(TObject *Sender)
{
DEBUG_LINE
	if (!Form1->ListView1->Enabled) // Modifi le 11/11/03)
	{
		Forms::Application->MessageBox(LoadStr(8001).c_str(), LoadStr(8002).c_str(), NULL);
    return;
  }
  Screen->Cursor = crAppStart; // 04/04/2004
  BoutonAnalyser->Enabled = false;
  StatusBar1->SimpleText = LoadStr(8003);
  FlagSuppr = true;
  ListView1->Items->Clear();
  IDPop3->OpenSync();
  IDPop3->MsgNum = StrToInt(pItem1->Caption);
  IDPop3->UidlSync();
	if (IDPop3->MsgUidl != pItem1->SubItems->Strings[6] || IDPop3->ErrorMessage != "")
  {
    Form1->MsgUidlFaux();
    IDPop3->QuitSync();
    BtnStop->Enabled = false;
    BoutonAnalyser->Enabled = true;
    FlagSuppr = false;
    Close();
  }
  else
  {
    MemoryStream1 = new TMemoryStream;
    MStream = new TMemoryStream;
    MimeDecode1 = new TMimeDecode(this);
    MimeDecode1->OnPartEnd = MimeDecode1PartEnd;
    MimeDecode1->OnPartBegin = MimeDecode1PartBegin;
    MimeDecode1->DestStream = MStream;
    ProgressBar1->Position = 0;
    ProgressBar1->Visible = true;
    nbOctet = 0;
    IDPop3->OnMessageLine = IDPop3MessageLine;
    IDPop3->OnMessageEnd =  IDPop3MessageEnd;
    IDPop3->ListSync();
    ProgressBar1->Max = IDPop3->MsgSize;
    MemoryStream1->Position = 0; // Seek(0, soFromBeginning);
    BtnStop->Enabled = true;
    BtnStop->Tag = 0;
    IDPop3->Retr(); // Remplace RetrSync 16/12/2003
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm8::FinMessage() // appel aussi par BtnStop
{
DEBUG_LINE
	BtnStop->Enabled = false;
	ProgressBar1->Visible = false;
//  StatusBar1->SimpleText = " Analyse en cours...";
	if (IDPop3->Connected) //  cause de Retr non synchro 16/12/2003
	{
		IDPop3->AbortSync();
		IDPop3->QuitSync();
	}
//  StatusBar1->Refresh();
//  Application->ProcessMessages();
	if (!BtnStop->Tag) // 04/04/2004
	{
		MemoryStream1->Position = 0;
		MimeDecode1->DecodeStream(MemoryStream1);
	}
	IDPop3->OnMessageLine = Form1->OnMessageLineProc;
	IDPop3->OnMessageEnd = NULL;
	delete MemoryStream1;
	delete MStream;
	delete MimeDecode1;
	if (!ListView1->Items->Count)
		ListView1->Items->Add()->SubItems->Add(LoadStr(8004));
	BoutonAnalyser->Enabled = true;
	FlagSuppr = false;
	Screen->Cursor = crDefault; // au cas o...
}
//---------------------------------------------------------------------------
// Lecture de chaque ligne du message
void __fastcall TForm8::IDPop3MessageLine(TObject *Sender)
{
DEBUG_LINE
	try // 11/11/2003
  {
    MemoryStream1->Write((void *)IDPop3->LastResponse.c_str(), IDPop3->LastResponse.Length());
    MemoryStream1->Write("\r\n", 2);
    ProgressBar1->Position = MemoryStream1->Position;
  }
  catch (Exception &exception)
  {
    ShowMessage(LoadStr(8005));
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm8::IDPop3MessageEnd(TObject *Sender) // 16/12/2003
{
DEBUG_LINE
	if (!BtnStop->Tag)
	{
		FinMessage();
		StatusBar1->SimpleText = LoadStr(8006);
	}
}
//---------------------------------------------------------------------------
// Dbut du dcodage de l'entete du bloc
void __fastcall TForm8::MimeDecode1PartBegin(TObject *Sender)
{
DEBUG_LINE
	StatusBar1->SimpleText = LoadStr(8007) + IntToStr(MimeDecode1->PartNumber) + LoadStr(8008);
}
//---------------------------------------------------------------------------
// Fin du dcodage de l'entete du bloc
void __fastcall TForm8::MimeDecode1PartEnd(TObject *Sender)
{
DEBUG_LINE
static TListItem *pItem;
AnsiString NomFic = Form1->DecodeObjet(MimeDecode1->PartFileName);
  if (MimeDecode1->PartContentType != "" || MimeDecode1->PartDisposition != "" ||
                                        MimeDecode1->ApplicationType != "" || NomFic != "")
  {
    pItem = ListView1->Items->Add();
    pItem->Caption = IntToStr(MimeDecode1->PartNumber);
    pItem->SubItems->Add(MimeDecode1->PartContentType);
    pItem->SubItems->Add(MimeDecode1->PartDisposition);
    pItem->SubItems->Add(NomFic);
		pItem->SubItems->Add(Form1->Separateur(MStream->Size, '.'));
    if (NomFic != "")
      pItem->ImageIndex = 6;
    else
      pItem->ImageIndex = -1;
		if (NomFic.SubString(NomFic.Length() - 2, 3).LowerCase() == "zip")
    {
      StatusBar1->SimpleText = LoadStr(8009);
      Forms::Application->ProcessMessages();
			if (AnalyseRecursive(MStream, NomFic) == -1)
				ShowMessage(LoadStr(8010) + NomFic + "'");
    }
    Screen->Cursor = crDefault;
    MStream->Clear();
  }
}
//---------------------------------------------------------------------------
// Bouton Stop
void __fastcall TForm8::BtnStopClick(TObject *Sender)
{
DEBUG_LINE
	IDPop3->Abort();
	BtnStop->Tag = 1;
	FinMessage();
	StatusBar1->SimpleText = LoadStr(8011);
	Screen->Cursor = crDefault; // 04/04/2004
}
//---------------------------------------------------------------------------
// Form Close
void __fastcall TForm8::FormClose(TObject *Sender, TCloseAction &Action)
{
DEBUG_LINE
	FlagSuppr = false; // au cas o...
	Screen->Cursor = crDefault; // au cas o...
}
//---------------------------------------------------------------------------
// Bouton Fermer
void __fastcall TForm8::Button1Click(TObject *Sender)
{
DEBUG_LINE
	Close();
}
//---------------------------------------------------------------------------
// Ne pas fermer pendant la lecture
void __fastcall TForm8::FormCloseQuery(TObject *Sender, bool &CanClose)
{
DEBUG_LINE
	if (Form8->Active)
		CanClose = !IDPop3->Connected;
}
//---------------------------------------------------------------------------
// Form Create
void __fastcall TForm8::FormCreate(TObject *Sender)
{
DEBUG_LINE
	StatusBar1->ControlStyle = StatusBar1->ControlStyle << csAcceptsControls ;
	ProgressBar1->Left = 0;
	ProgressBar1->Top = 2;
	ProgressBar1->Parent = StatusBar1;
	ProgressBar1->Align = alClient;
}
//---------------------------------------------------------------------------
void __fastcall TForm8::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
DEBUG_LINE
	if (Key == VK_F1)
		Form1->Aide(LoadStr(30000));
}
//---------------------------------------------------------------------------
// Bouton "Aide"
void __fastcall TForm8::BtnAideClick(TObject *Sender)
{
DEBUG_LINE
	Form1->Aide(LoadStr(30000));
}
//---------------------------------------------------------------------------
// Fonction Rcursive d'analyse de ZIP ajout le 13/12/2003
int __fastcall TForm8::AnalyseRecursive(TMemoryStream *MStream, AnsiString Fic)
{
DEBUG_LINE
TMemoryStream *MonStream = new TMemoryStream;
TZFArchiveItem ArchiveItem;
AnsiString NomFic;
static TListItem *pItem;
int Ret = 0;
static int NbRecur = 0;
int x;

///TAbZipArchive *AbZipArchive = new TAbZipArchive(MStream, Fic);
///	 AbZipArchive->OnProcessItemFailure = TAbArchiveItemFailureEvent;
TZipForge *ZipForge0 = new TZipForge(this);
	ZipForge0->OnProcessFileFailure = ZipForge1ProcessFileFailure;
	try
	{
///		AbZipArchive->Load();
		ZipForge0->OpenArchive(MStream, false);
///		AbZipArchive->ExtractToStreamHelper = UnZipToStreamHelper;

///		for (int z = 0 ; z < AbZipArchive->Count ; z++)
		if (ZipForge0->FileCount && ZipForge0->FindFirst("*.*", ArchiveItem, faAnyFile-faDirectory))
		{
			do
			{
///			NomFic = AbZipArchive->Items[z]->FileName;
				NomFic = ArchiveItem.FileName;
				pItem = ListView1->Items->Add();
				pItem->SubItems->Add(LoadStr(8012));
				pItem->SubItems->Add("");
				pItem->SubItems->Add(AnsiString::StringOfChar('>', NbRecur+1) + ' ' + NomFic);
///			pItem->SubItems->Add(Separateur(AbZipArchive->Items[z]->UncompressedSize, '.'));
				pItem->SubItems->Add(Form1->Separateur(ArchiveItem.UncompressedSize, '.'));
				pItem->ImageIndex = -1;
				if (NomFic.SubString(NomFic.Length() - 2, 3).LowerCase() == "zip")
				{
///				AbZipArchive->ExtractToStream(NomFic, MonStream);
					ZipForge0->ExtractToStream(NomFic, MonStream);
					if (NbRecur++ < 20)
					{
						if (AnalyseRecursive(MonStream, NomFic) == -1)
							ShowMessage(LoadStr(8010) + NomFic + "'");
						NbRecur--;
					}
					MonStream->Clear();
				}
			}
			while (ZipForge0->FindNext(ArchiveItem));
		}
	}
	catch (Exception &exception)
	{
		Ret = -1;
	}
///	delete AbZipArchive;
	delete ZipForge0;
	delete MonStream;
	return Ret;
}
//---------------------------------------------------------------------------
/*void __fastcall TForm8::TAbArchiveItemFailureEvent(TObject *Sender, TAbArchiveItem *Item,
								const TAbProcessType ProcessType, TAbErrorClass ErrorClass, int ErrorCode)
{
	if (ErrorClass == ecAbbrevia)
		ShowMessage(AbStrRes(ErrorCode));
} */
//---------------------------------------------------------------------------
/*void __fastcall TForm8::UnZipToStreamHelper(TObject *Sender, TAbArchiveItem *Item, TStream *MonStream)
{
	if (MonStream)
		AbUnzipToStream((TAbZipArchive*)Sender, (TAbZipItem*)Item, MonStream);
}*/
//---------------------------------------------------------------------------
// 01/05/2006
void __fastcall TForm8::ZipForge1ProcessFileFailure(TObject *Sender, AnsiString FileName,
			TZFProcessOperation Operation, int NativeError, int ErrorCode, AnsiString ErrorMessage,
			TZFAction &Action)
{
DEBUG_LINE
	ShowMessage(IntToStr(ErrorCode));
}
//---------------------------------------------------------------------------

