//---------------------------------------------------------------------------
// Ajout le 29/03/2008
#include <vcl.h>
#pragma hdrstop

#include "OutClockJoker.h"
#include "OutClock1.h"
#include "OutClockJokerSaisie.h"
#include "OutClockRejets.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormJoker *FormJoker;
//---------------------------------------------------------------------------
__fastcall TFormJoker::TFormJoker(TComponent* Owner) : TForm(Owner)
{
TListItem *pItem;
	AJoker = Form1->ini->ReadString(NOM_APPLI, "ListeJokers", ""); // 31/03/2008
	for (size_t i=0 ; i < (size_t)StringGrid1->ColCount && i < (size_t)AJoker.Length() ; i++)
		StringGrid1->Rows[0]->Add(AJoker[i+1]);
}
//---------------------------------------------------------------------------
void __fastcall TFormJoker::FormActivate(TObject *Sender)
{
	InitFiche();
	Selection = -1;
}
//---------------------------------------------------------------------------
// Bouton Copier
void __fastcall TFormJoker::BtnCopierClick(TObject *Sender)
{
char Buf[2] = "\0\0";

	if (Selection != -1)
	{
		Buf[0] = AJoker[Selection+1];
		Clipboard()->Open();
		Clipboard()->SetTextBuf(Buf);
		Clipboard()->Close();
	}
}
//---------------------------------------------------------------------------
// Choix d'un caractre
void __fastcall TFormJoker::StringGrid1SelectCell(TObject *Sender, int ACol, int ARow,
			bool &CanSelect)
{
	Selection = ACol;
	BtnAjouter->Enabled = true;
	BtnCopier->Enabled = true;
}
//---------------------------------------------------------------------------
// Clic dans la liste des items
void __fastcall TFormJoker::ListViewJokerSelectItem(TObject *Sender, TListItem *Item, bool Selected)
{
	BtnModifier->Enabled = Selected; // 06/03/2013
	BtnSupprimer->Enabled = Selected;
}
//---------------------------------------------------------------------------
void __fastcall TFormJoker::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	switch (Key) {
		case VK_ESCAPE :    FormJoker->Close(); break;
		case VK_F1 :        Form1->Aide("principal");
	}
}
//---------------------------------------------------------------------------
// Bouton Fermer
void __fastcall TFormJoker::BtnFermerClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
// Bouton Ajouter
void __fastcall TFormJoker::BtnAjouterClick(TObject *Sender)
{
TListItem *pItem;
AnsiString iniListe;

	if (Form1->AsJokersPerso.AnsiPos(AJoker[Selection+1]))
	{
		ShowMessage("Ce joker existe dj");
		return;
	}
	FormJokerSaisie->Label4->Caption = AJoker[Selection+1]; // 06/03/2013
	FormJokerSaisie->Edit1->Enabled = true;
	FormJokerSaisie->Edit1->Text = "";
	FormJokerSaisie->Edit2->Text = "";
	if (FormJokerSaisie->ShowModal() == mrOk)
	{
		for (int i = 0 ; i < ListViewJoker->Items->Count ; i++)
		{
			pItem = ListViewJoker->Items->Item[i];
			if (pItem->Caption == FormJokerSaisie->Edit1->Text)
			{
				ShowMessage("Un joker portant ce nom existe dj");
				return;
			}
		}

		sJoker *lJoker = new sJoker;
		lJoker->Joker = AJoker[Selection+1];
		lJoker->Liste = FormJokerSaisie->Edit2->Text;
		Form1->pListeJoker->Add(lJoker);
		Form1->AsJokersPerso += lJoker->Joker;
		iniListe = lJoker->Joker;
		iniListe +=",";
		iniListe += lJoker->Liste;
		Form1->ini->WriteString("JokerPerso", FormJokerSaisie->Edit1->Text, iniListe);
		pItem = ListViewJoker->Items->Add();
		pItem->Caption = FormJokerSaisie->Edit1->Text;
		pItem->SubItems->Add(lJoker->Joker);
		pItem->SubItems->Add(lJoker->Liste);
		InitFiche();
	}
}
//---------------------------------------------------------------------------
// Bouton Modifier
void __fastcall TFormJoker::BtnModifierClick(TObject *Sender)
{
TListItem *pItem;
AnsiString Libelle, iniListe;

	if (ListViewJoker->Selected == 0) // 06/03/2013 pour double-clic
		return;
	FormJokerSaisie->Edit1->Enabled = false;
	pItem = ListViewJoker->Items->Item[ListViewJoker->Selected->Index];
	FormJokerSaisie->Edit1->Text = pItem->Caption;
	FormJokerSaisie->Edit2->Text = pItem->SubItems->Strings[1];
	Libelle = FormJokerSaisie->Edit2->Text;
	FormJokerSaisie->Label4->Caption = pItem->SubItems->Strings[0]; // 06/03/2013
	if (FormJokerSaisie->ShowModal() == mrOk)
	{
		if (Libelle != FormJokerSaisie->Edit2->Text)
		{
			sJoker *lJoker = (sJoker*)Form1->pListeJoker->Items[ListViewJoker->Selected->Index];
			pItem->SubItems->Strings[1] = FormJokerSaisie->Edit2->Text;
			lJoker->Liste = FormJokerSaisie->Edit2->Text;
			iniListe = lJoker->Joker;
			iniListe +=",";
			iniListe += lJoker->Liste;
			Form1->ini->WriteString("JokerPerso", FormJokerSaisie->Edit1->Text, iniListe);
		}
	}
	InitFiche();
}
//---------------------------------------------------------------------------
// Double-clic sur un item (modifier) 06/03/2013
// Bouton Supprimer
void __fastcall TFormJoker::BtnSupprimerClick(TObject *Sender)
{
TListItem *pItem, *pItemL;
AnsiString JokerListe;
char cJoker;

	pItem = ListViewJoker->Items->Item[ListViewJoker->Selected->Index];
	if (Forms::Application->MessageBox(("Supprimer le Joker Perso '" +	pItem->Caption + "'").c_str(),
						"Suppression d'un Joker Perso", MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDYES)
	{
		cJoker = pItem->SubItems->Strings[0][1];
		JokerListe = pItem->SubItems->Strings[1];
		Form1->AfficheSB(0, "Recherche filtre avec joker perso");
		for (int i = 0 ; i < 3 ; i++) // recherche dans les 3 listes de filtres
		{
			for (int j = 0 ; j < FormRejets->Liste[i]->Items->Count ; j++)
			{
				pItemL = FormRejets->Liste[i]->Items->Item[j];
				if (pItemL->Caption.AnsiPos(cJoker))
				{
					ShowMessage("Au moins un filtre utilise ce joker\n\nSuppression interrompue");
					return;
				}
			}
		}
		Form1->ini->WriteString("JokerPerso", pItem->Caption, "");
		delete Form1->pListeJoker->Items[ListViewJoker->Selected->Index]; // supprime l'objet lJoker
		Form1->pListeJoker->Delete(ListViewJoker->Selected->Index) ; // supprime l'item de pListeJoker
		Form1->AsJokersPerso.Delete(ListViewJoker->Selected->Index + 1, 1);
		pItem->Delete();
	}
	InitFiche();
}
//---------------------------------------------------------------------------
// Appel de l'Aide
void __fastcall TFormJoker::BtnAideClick(TObject *Sender)
{
	Form1->Aide(LoadStr(30009));
}
//---------------------------------------------------------------------------
void __fastcall TFormJoker::InitFiche()
{
static TGridRect MonRect;
	MonRect.Left = -1;
	MonRect.Top = -1;
	MonRect.Right = -1;
	MonRect.Bottom = -1;
	StringGrid1->Selection = MonRect;
	ListViewJoker->Selected = 0;
	BtnAjouter->Enabled = false;
	BtnModifier->Enabled = false;
	BtnSupprimer->Enabled = false;
	BtnCopier->Enabled = false;
}
void __fastcall TFormJoker::FormResize(TObject *Sender)
{
	ListViewJoker->Width = ClientWidth - 104;
	ListViewJoker->Height = ClientHeight - 140;
	ListViewJoker->Columns->Items[2]->Width = ClientWidth - 272;
}
//---------------------------------------------------------------------------

