//---------------------------------------------------------------------------
// HelpContext contient, pour chaque liste, son indice
#include <vcl.h>
#pragma hdrstop

#include <typeinfo.h>

#include "OutClockRejets.h"
#include "OutClock1.h"
#include "OutClock6.h"
#include "OutClock7.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AdvListV"
#pragma resource "*.dfm"
#define min(a,b) (((a)<(b))?(a):(b))
TFormRejets *FormRejets;
AnsiString Extension[6] = {".rej",".rjs", ".rjd", "", "", ".his"};
char cAvant[] = "Rdgc ";
char cExecuter[] = "Novs";
char cInclure[] = " acx";
char cDest[] = "ACL";
bool CBRejterInex;
int RejeterInex;
char *PtrTok;
//---------------------------------------------------------------------------
__fastcall TFormRejets::TFormRejets(TComponent* Owner) : TForm(Owner)
{
DEBUG_LINE
	CouleurItem[0] = (TColor)0xFFEEFF;  CouleurItem[1] = (TColor)0xFFFFDD;
	CouleurItem[2] = (TColor)0xCCEEFF;  CouleurItem[5] = (TColor)0xEEEEEE;
	Liste[0] = ListeAdr;  Liste[1] = ListeSuj;  Liste[2] = ListeDest; Liste[5] = ListeHist;
	TabControl1->Images = Form1->ImageList4;
}
//---------------------------------------------------------------------------
// Form Create
void __fastcall TFormRejets::FormCreate(TObject *Sender)
{
DEBUG_LINE
	ReadIni();
}
//---------------------------------------------------------------------------
// Lit les paramtres de OutClock.ini
void __fastcall TFormRejets::ReadIni()
{
DEBUG_LINE
AnsiString As;
int i;
	Edit2->Text = Form1->ini->ReadString(NOM_APPLI, "SMTPServeur", "smtp.fai.com");
	CheckBoxAuth->Checked = Form1->ini->ReadBool(NOM_APPLI, "SMTPAuth", 0); // 21/07/2007
	CheckBoxAuthClick(this); // EditAuthMdP->Enabled - 21/07/2007
	Edit3->Text = Form1->ini->ReadString(NOM_APPLI, "SMTPId", "identifiant");
	EditAuthMdP->Text = Form1->LitMdP(Form1->ini->ReadString(NOM_APPLI, "SMTPMdP", "motdepasse")); // 19/08/2007
	ComboSMTPPort->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI,"PortSMTP", 0); // 0 = 25 / 1 = 587

	As = Form1->ini->ReadString(NOM_APPLI, "SpamTexte", Memo1->Text);
	EditExped->Text = Form1->ini->ReadString(NOM_APPLI, "SMTPExped", "");
	while ((i = As.AnsiPos("")) > 0)
	{
		As[i] = '\r';
		As[i+1] = '\n';
	}
	Memo1->Text = As;
	SetWindowLong(Edit7->Handle, GWL_STYLE,GetWindowLong(Edit7->Handle, GWL_STYLE)| ES_NUMBER);
	SetWindowLong(Edit6->Handle, GWL_STYLE,GetWindowLong(Edit6->Handle, GWL_STYLE)| ES_NUMBER);
	UpDown1->Position = Form1->ini->ReadInteger(NOM_APPLI, "NbHisto", 500);
	CheckBox1->Checked = Form1->ini->ReadBool(NOM_APPLI, "HistoNbLigSav", true);
	UpDown2->Position = Form1->ini->ReadInteger(NOM_APPLI, "NbHistoDate", 15);
	CheckBox2->Checked = Form1->ini->ReadBool(NOM_APPLI, "HistoDateSav", true);
	CheckBoxRejeterInex->Checked = Form1->ini->ReadBool(NOM_APPLI, "RejetInex", false);
	if (CheckBoxRejeterInex->Checked) Form1->StatusBar1DblClick(this); // 13/11/2004
	ConditionsRejetInex->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI,"ConditionsRejetInex", 0);
	RadioGroupAvantInex->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "AvantRejetInex",
                                                        RadioGroupAvantInex->ItemIndex); // 24/01/2004
  if ((As = Form1->GetDNS()) == "")
    EditDNS->Text = Form1->ini->ReadString(NOM_APPLI, "IPDns", "");
  ComboBoxSujetVide->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "SujetVide", 3); // garder toujours, pass  '3' le 03/05/2004
	CheckBoxRejeterInexClick(this);
	ComboBoxDestA->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "DestAVide", 3);
	ComboBoxPasArobase->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "DestPasArobase", 3);
	CheckBoxExpEtSujet->Checked = Form1->ini->ReadBool(NOM_APPLI,"ExpEtSujetDetruire", false);
	GroupFromReturnPath->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "FromReturnPath", 1); // 04/05/2006
	Form1->ListView1->Columns->Items[1]->Caption = LoadStr(10011 +GroupFromReturnPath->ItemIndex);
int Largeur;
	for (i = 0 ; i < ListeHist->Columns->Count ; i++) // 13/10/2004
  {
		Largeur = Form1->ini->ReadInteger(NOM_APPLI, "ColHist" + IntToStr(i), 0);
    if (Largeur > 0)
      ListeHist->Columns->Items[i]->Width = Largeur;
  }
}
//---------------------------------------------------------------------------
// Form Activate
void __fastcall TFormRejets::FormActivate(TObject *Sender)
{
DEBUG_LINE
	if (!FormRejets->Tag)
	{
		PosIni();
		FormRejets->Tag = 1;
	}
	TabControl1Change(Sender);
}
//---------------------------------------------------------------------------
// Appel par Form1 au lancement du programme
void __fastcall TFormRejets::Creation(TObject *Sender)
{
DEBUG_LINE
int NbCol;
AnsiString Fic;
TListItem *pItem;
char *Ch;
	Form1->AfficheSB(0, LoadStr(3004));
	try // 21/08/2007
	{
		for (int i = 0 ; i < 6 ; i++) // 4 listes  sauvegarder - Extension[3] et Extension[4] inexistantes
		{
			if (Liste[i])
			{
				Fic = ChangeFileExt(Forms::Application->ExeName, Extension[i]);
				if (!Liste[i]->Items->Count && FileExists(Fic))
				{
					NbCol = Liste[i]->Columns->Count;
					OuvreFic(i, Fic); // 20/10/2004
					if (Liste[i]->Columns->Count > NbCol) // 20/03/2004 - 30/03/2004
					{
						AnsiString AsErr = LoadStr(3043) + Fic + LoadStr(3044) +
									IntToStr(Liste[i]->Columns->Count) + LoadStr(3045) +
									IntToStr(NbCol) + LoadStr(3046); // 24/04/2004
						if (Forms::Application->MessageBox(AsErr.c_str(), LoadStr(3047).c_str(), MB_YESNO) == IDYES)
						{
							Screen->Cursor = crHourGlass;
							while (Liste[i]->Columns->Count > NbCol)
							{
								for (int j = 0 ; j < Liste[i]->Items->Count ; j++)
								{
									pItem = Liste[i]->Items->Item[j];
									if (pItem->SubItems->Count > NbCol - 1)
										pItem->SubItems->Delete(pItem->SubItems->Count - 1);
								}
								Liste[i]->Columns->Delete(NbCol);
							}
							Liste[i]->Tag = 1;
							Screen->Cursor = crDefault;
						}
						else
							Forms::Application->Terminate(); // 24/04/2004
					}
				}
			}
		}
	}
	catch (Exception &exception) // 21/08/2007
	{
		Forms::Application->MessageBox((LoadStr(5004) + Fic).c_str(), LoadStr(1076).c_str(), MB_ICONERROR); // 21/08/2007
		Screen->Cursor = crDefault;
	}
	TabControl1->TabIndex = 0;
	TabControl1Change(Sender);
	for (int i = 0 ; i < 3 ; i++)
	{
		for (int j = 0 ; j < Liste[i]->Items->Count ; j++)
		{
			try
			{
				pItem = Liste[i]->Items->Item[j];
				Ch = pItem->SubItems->Strings[0].c_str();
				if (*Ch == 'm') // ancienne version
					*Ch = 'g';
				if (*Ch == 'D') // ancienne version
					*Ch = 'd';
				pItem->ImageIndex = pItem->SubItems->Strings[Liste[i]->Columns->Count -2] == "A";
			}
			catch (Exception &exception)
			{
				pItem->ImageIndex = false; // Rejet
			}
		}
		Liste[i]->CustomSort(TriListe, i); // 28/10/2007
	}
	Form1->DnsQuery1->Addr = Form1->ini->ReadString(NOM_APPLI, "IPDns", "");
	EditDNS->Text = Form1->DnsQuery1->Addr;
	Form1->AfficheSB(0, "");
}
//---------------------------------------------------------------------------
// Changement d'onglet
void __fastcall TFormRejets::TabControl1Change(TObject *Sender)
{
DEBUG_LINE
	for (int i = 0 ; i < 6 ; i++)
    if (Liste[i] != NULL)
    {
      Liste[i]->Align = alClient;
      Liste[i]->Visible = TabControl1->TabIndex == i;
    }
  PanelReponse->Align = alClient;
	PanelInexistant->Align = alClient;
  Panel1->Visible = TabControl1->TabIndex == 5;
  PanelHaut->Visible = Panel1->Visible;
	PanelHautRej->Visible = (TabControl1->TabIndex <= 2);
  LblMM->Visible = TabControl1->TabIndex == 1 || TabControl1->TabIndex == 2;
  PanelDest->Visible = TabControl1->TabIndex == 2;
  PanelBas->Visible = TabControl1->TabIndex != 3 && TabControl1->TabIndex != 4;
  Label19->Caption = "";
	CheckBoxExpEtSujet->Visible = false;
	GroupFromReturnPath->Visible = false;
	Panel3->Visible = TabControl1->TabIndex <= 2;
	Btn0rejet->Visible = Panel3->Visible;
	PanelReponse->Visible = TabControl1->TabIndex == 3;
	PanelInexistant->Visible = TabControl1->TabIndex == 4;
	LblSujetVide->Visible = TabControl1->TabIndex == 1;
	ComboBoxSujetVide->Visible = LblSujetVide->Visible;
	PanelDestVide->Visible = TabControl1->TabIndex == 2;
	switch (TabControl1->TabIndex)
	{
		case 0 :    Label15->Caption = LoadStr(3005); Label19->Caption = LoadStr(3006);
								CheckBoxExpEtSujet->Visible = true;
								GroupFromReturnPath->Visible = true;  // 04/05/2006
								CheckBoxExpEtSujet->Caption = LoadStr(6012) +
												IntToStr(Form1->DelaiRejeterGarder) + LoadStr(6013); // 24/05/2006
								break;
		case 1 :    Label15->Caption = LoadStr(3007); GarderDetruire(); break;
		case 2 :    Label15->Caption = LoadStr(3008); GarderDetruire(); break;
		case 4 :    for (int i = 1; i <= 2 ; i++ )
											RadioGroupAvantInex->Items->Strings[i] = LoadStr(6009+i) +
											IntToStr(Form1->DelaiRejeterGarder)+ " sec.";
								break;
		case 5 :    BtnVideHisto->Enabled = BtnRech->Enabled; NombreRejets(); break;
	}
	if (TabControl1->TabIndex != 3 && TabControl1->TabIndex != 4) // autre que Rponse & Inex
  {
    BtnRech->Enabled = Liste[TabControl1->TabIndex]->Items->Count;
    BtnImpr->Enabled = BtnRech->Enabled;
    Btn0rejet->Enabled = BtnRech->Enabled;
		ExporterauformatExcel1->Enabled = BtnRech->Enabled;
    if (TabControl1->TabIndex != 5) // autre que Hist
    {
      BtnSuppr->Enabled = Liste[TabControl1->TabIndex]->Selected;
      BtnModif->Enabled = BtnSuppr->Enabled;
      Supprimeruneadresse1->Enabled = BtnSuppr->Enabled;
      Modifieruneadresse1->Enabled = BtnSuppr->Enabled;
    }
  }
  try
	{
		if (TabControl1->TabIndex != 3  && TabControl1->TabIndex != 4 && FormRejets->Visible) // Rponse
			Liste[TabControl1->TabIndex]->SetFocus();
	}
	catch (Exception &exception) { ; }
}
//----------------------------- Onglet REPONSE ------------------------------
// Bouton OK
void __fastcall TFormRejets::BtnRepOKClick(TObject *Sender)
{
DEBUG_LINE
	if (!Teste587Ok())
		return;
	if (Memo1->Modified)
	{
AnsiString As = Memo1->Text;
int i;
		while ((i = As.AnsiPos("\r\n")) > 0)
		{
			As[i] = ''; //  cause retours chariot
			As[i+1] = '';  // et saut de ligne
		}
		Form1->ini->WriteString(NOM_APPLI, "SpamTexte", As);
		Memo1->Modified = false;
	}
	if (Edit2->Modified)
	{
		Form1->ini->WriteString(NOM_APPLI, "SMTPServeur", Edit2->Text);
		Edit2->Modified = false;
	}
	if (Edit3->Modified)
	{
		Form1->ini->WriteString(NOM_APPLI, "SMTPId", Edit3->Text);
		Edit3->Modified = false;
	}
	if (EditExped->Modified)
	{
		Form1->ini->WriteString(NOM_APPLI, "SMTPExped", EditExped->Text);
		EditExped->Modified = false;
	}
	if (EditAuthMdP->Modified)
	{
		Form1->ini->WriteString(NOM_APPLI, "SMTPMdP", Form1->EcritMdP(EditAuthMdP->Text)); // 19/08/2007
		EditAuthMdP->Modified = false;
	}
	Form1->ini->WriteInteger(NOM_APPLI, "PortSMTP", ComboSMTPPort->ItemIndex); // 0 = 25 / 1 = 587
	Form1->ini->WriteBool(NOM_APPLI, "SMTPAuth", CheckBoxAuth->Checked); // 21/07/2007
}
//---------------------------------------------------------------------------
// Clavier dans Memo1
void __fastcall TFormRejets::Memo1KeyPress(TObject *Sender, char &Key)
{
DEBUG_LINE
	if (Key == '[' || Key == ']' || Key == '=')
		Key = 0x7;
	else if (Key == 0x1B) // ESC
		FormRejets->Close();
}
//---------------------------------------------------------------------------
// Bouton "Tester" SMTP
void __fastcall TFormRejets::BtnTesterClick(TObject *Sender)
{
DEBUG_LINE
AnsiString As;
	if (!Teste587Ok())
		return;
	Label7->Caption = "";
	if (!InputQuery(LoadStr(3009), LoadStr(3010) , As) || As == "")
		return;
	TSyncSmtpCli *SyncSmtpCli1 = new TSyncSmtpCli(this);
	if (EditExped->Text != "")
		SyncSmtpCli1->HdrFrom = EditExped->Text;
	 else
		SyncSmtpCli1->HdrFrom = "postmaster@outclock.org";
	SyncSmtpCli1->FromName = SyncSmtpCli1->HdrFrom;
	SyncSmtpCli1->Host = Edit2->Text;
	SyncSmtpCli1->Username = Edit3->Text;
	if (CheckBoxAuth->Checked) // 21/07/2007
	{
		SyncSmtpCli1->AuthType = smtpAuthAutoSelect;
		SyncSmtpCli1->Password = EditAuthMdP->Text;
	}
	SyncSmtpCli1->Port = ComboSMTPPort->Text; // 24/07/2007
	SyncSmtpCli1->HdrSubject = LoadStr(3011);
	SyncSmtpCli1->MailMessage->Text = LoadStr(3012);
	SyncSmtpCli1->RcptName->Text = As;
	SyncSmtpCli1->HdrTo = As; // 21/07/2007
  Screen->Cursor = crHourGlass;
  try
  {
    SyncSmtpCli1->OpenSync();
    Label7->Caption = SyncSmtpCli1->LastResponse;
    SyncSmtpCli1->MailSync();
    Label7->Caption = Label7->Caption + "\r\n" + SyncSmtpCli1->LastResponse;
    SyncSmtpCli1->QuitSync();
    ShowMessage(LoadStr(3013));
  }
	catch (Exception &exception)
  {
    ShowMessage(LoadStr(3014));
  }
  delete SyncSmtpCli1;
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
//---------------------------- Onglet Historique ----------------------------
// bouton "Vider" l'historique
void __fastcall TFormRejets::BtnVideHistoClick(TObject *Sender)
{
DEBUG_LINE
	if (Forms::Application->MessageBox(LoadStr(3015).c_str(), LoadStr(3016).c_str(),
																				MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDNO)
		return;
	ListeHist->Items->Clear();
	ListeHist->Tag = 1;
	TabControl1Change(Sender); // Positionne les boutons
}
//---------------------------------------------------------------------------
// Compare 2 DateTime. Rcrit le 29/02/2004
int __fastcall TFormRejets::HistCompareDate(AnsiString str1, AnsiString str2)
{ // Renvoie le nombre de jours (str2 - str1)
DEBUG_LINE
int resultat = 0; // variable cre le 22/05/2004
  try  // si le champ Date n'est pas conforme
  {
    resultat = (int)(StrToDateTime(str2) - StrToDateTime(str1));
  }
  __finally
	{
    return resultat;
  }
}
//---------------------------------------------------------------------------
// Evnement pour choisir le type tri de l'Historique
void __fastcall TFormRejets::ListeHistGetFormat(TObject *Sender, int ACol,
                                TSortStyle &AStyle, AnsiString &aPrefix, AnsiString &aSuffix)
{
DEBUG_LINE
	if (ACol == -1)
		AStyle = ssDate;
	else
		AStyle = ssAlphaNoCase;
}
//---------------------------------------------------------------------------
// Bouton Fermer Histo
void __fastcall TFormRejets::FermerHisto()
{
DEBUG_LINE
	if (UpDown1->Position < 10)
		UpDown1->Position = 10;
	if (UpDown2->Position < 10)
		UpDown2->Position = 10;
	ApureHisto();
}
//---------------------------------------------------------------------------
// Appure l'historique
void __fastcall TFormRejets::ApureHisto()
{
DEBUG_LINE
	if (CheckBox1->Checked || CheckBox2->Checked) // ajout le 22/05/2004
	{
		ListeHist->SortDirection = sdDescending;
		ListeHist->SortColumn = 0; // DateHeure
	}
	if (CheckBox1->Checked) // 15/08/2003
		while (ListeHist->Items->Count > UpDown1->Position)
		{
			ListeHist->Items->Delete(ListeHist->Items->Count - 1);
			ListeHist->Tag = 1;
		}
	if (CheckBox2->Checked) // 15/08/2003
	{
		AnsiString DateRef = DateTimeToStr(Now() - UpDown2->Position); // modifi le 29/02/2004
		for (int i = 0 ; i < ListeHist->Items->Count ; i++)  // Apure selon date
			if (HistCompareDate(DateRef, ListeHist->Items->Item[i]->Caption) <= 0)
			{
				ListeHist->Items->Delete(i--);
				ListeHist->Tag = 1;
			}
	}
}
//--------------------------- Fonctions communes-----------------------------
// Bouton Fermer
void __fastcall TFormRejets::BtnRepFermerClick(TObject *Sender)
{
	if (Teste587Ok())
		FormRejets->Visible = false;
}
//---------------------------------------------------------------------------
// Dessine un item d'une liste
void __fastcall TFormRejets::ListeAdrDrawItemProp(TObject *Sender, int itemindex,
 int subitemindex, TOwnerDrawState AState, TBrush *ABrush, TFont *AFont, AnsiString ItemText)
{
DEBUG_LINE
	TAdvListView *Liste = dynamic_cast<TAdvListView *>(Sender);
	if (itemindex & 1)
		ABrush->Color = CouleurItem[Liste->HelpContext];
	if (subitemindex == -1)
		if (ItemText[1] == '')
			AFont->Color = clFuchsia;
		else if (ItemText[1] == '')
			AFont->Color = clBlue;
	if (TabControl1->TabIndex == 5 // historique
			&& ListeHist->Items->Count > 0 // 21/05/2006
			&& ItemText != "")
	{
		try
		{
			if (ListeHist->Items->Item[itemindex]->SubItems->Strings[4].AnsiPos("\xA0")) // champ "Boite" 30/07/2005
				AFont->Color = clOlive; // suppression manuelle
			else if (ItemText.SubString(1, 3) == "->\x0A0")
				AFont->Color = clBlue;
			else if (ItemText.SubString(1, 3) == "=>\x0A0")
				AFont->Color = clGreen;
			else if (ItemText[ItemText.Length()] == '\x0A0')
				AFont->Color = clRed;
			else if (ItemText[ItemText.Length()] == '\x0B7')
				AFont->Color = clPurple;
		}
		catch(...)
		{
			;
		}
	}
}
//---------------------------------------------------------------------------
// Bouton Crer
void __fastcall TFormRejets::BtnCreerClick(TObject *Sender)
{
DEBUG_LINE
TListItem *pItem = NULL; // = NULL : 07/06/2004
AnsiString As, AsRejet;
int DynC = 0;
  Form6->RadioButtonRejeter->Checked = true;
  if (dynamic_cast<TMenuItem *>(Sender) == Form1->Ajoutelexpditeurrejets1)
		DynC =1;
	else if (dynamic_cast<TMenuItem *>(Sender) == Form1->Ajoutelesujetlalistedesrejets1)
		DynC =2;
	if (DynC)  // 19/03/2005
	{
		TListItem *pItem1 = Form1->ListView1->Items->Item[Form1->ListView1->Selected->Index];
		if (DynC == 1)
		{
			AsRejet = LowerCase(Form1->SupprFiltre(pItem1->SubItems->Strings[0]));
//			if (GroupFromReturnPath->ItemIndex < 2) // autre que "From avec Alias" 14/05/2006
			AsRejet = Form1->ExtraitEmail(AsRejet);
		}
		else
			AsRejet = LowerCase(Form1->SupprFiltre(pItem1->SubItems->Strings[1])); // 19/03/2005
		Form6->Edit1->Text = AsRejet;
		Form6->Edit2->Text = AsRejet;
	}
	else if (dynamic_cast<TBitBtn *>(Sender) == Form7->BtnAmi)
	{
		Form6->Edit1->Text = Form1->ExtraitEmail(Form7->LblExp->Caption);
		Form6->Edit2->Text = Form6->Edit1->Text;
		Form6->RadioButtonAccepter->Checked = true; // ami
		Form6->RadioGroupType->ItemIndex = 0; // exact
	}
	else
	{
		Form6->RadioGroupType->ItemIndex = 0; // rejet global
		Form6->Edit1->Text = "";
		Form6->Edit2->Text = "";
		Form6->RadioGroupAvant->ItemIndex = 2; // demander mais garder
		Form6->RadioGroupReponse->ItemIndex = 0; // ne pas rpondre
		Form6->RadioGroupInclure->ItemIndex = 0; // ne rien inclure
		Form6->RadioGroupDest->ItemIndex = 0; // Destinataire 'A'
	}
	if (dynamic_cast<TBitBtn *>(Sender) != Form7->BtnAmi)
	{
		Form6->RadioGroupType->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "TypeRejet",
																													 Form6->RadioGroupType->ItemIndex);
		if (TabControl1->TabIndex == 0 && Form6->RadioGroupType->ItemIndex > 1)
			Form6->RadioGroupType->ItemIndex = 1; // n'existe pas pour expditeurs
		if (TabControl1->TabIndex == 2 && Form6->RadioGroupType->ItemIndex > 2)
			Form6->RadioGroupType->ItemIndex = 1; // n'existe pas pour destinataire
		Form6->RadioGroupAvant->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "AvantRejet",
																													Form6->RadioGroupAvant->ItemIndex);
		Form6->RadioGroupReponse->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI, "ReponseRejet",
																												Form6->RadioGroupReponse->ItemIndex);
		Form6->RadioGroupInclure->ItemIndex = Form1->ini->ReadInteger(NOM_APPLI,"ReponseInclure",
																												Form6->RadioGroupInclure->ItemIndex);
		Form6->RadioGroupInclure->Enabled = Form6->RadioGroupReponse->ItemIndex;
		Form6->Caption = LoadStr(3042) + Form6Label1Caption(); // 14/05/2006
		Form6->Label1->Caption = "&" + Form6Label1Caption(); // 14/05/2006
	}
	do
		Form6->ShowModal();
  while (Form6->ModalResult == mrOk && Form6->Edit1->Text == "");
  if (Form6->ModalResult == mrOk)
  {
    if (TesteRejetExiste()) // 20/03/2004
      return;
    As = Form6->EditType->Text + Form6->Edit1->Text;
    pItem = Liste[TabControl1->TabIndex]->Items->Add();
		pItem->Caption = As;
    if (TabControl1->TabIndex == 2) // Destinataire
      pItem->SubItems->Add(cDest[Form6->RadioGroupDest->ItemIndex]);
    pItem->SubItems->Add(Form6->RadioButtonRejeter->Checked == true ?
								cAvant[Form6->RadioGroupAvant->ItemIndex] : ' ');
    if (Form6->RadioButtonRejeter->Checked)
		{
      As = cExecuter[Form6->RadioGroupReponse->ItemIndex];
			if (Form6->RadioGroupReponse->ItemIndex == 0)
        As += " ";
      else
        As += cInclure[Form6->RadioGroupInclure->ItemIndex];
    }
    else
      As = " ";
    pItem->SubItems->Add(As);
    Liste[TabControl1->TabIndex]->Tag = 1;
    Form1->Ajoutelexpditeurrejets1->Tag = pItem->Index; // pour incrmenter si suppression message 28/04/03
    pItem->ImageIndex = Form6->RadioButtonAccepter->Checked;
    Liste[TabControl1->TabIndex]->Selected = NULL; // Tout dslectionner 07/07/2005
    Liste[TabControl1->TabIndex]->SelectItem(pItem->Index); // 04/02/2004
  }
  Liste[TabControl1->TabIndex]->SortDirection = sdAscending; // 30/04/2004
  Liste[TabControl1->TabIndex]->SortColumn = 0; // 30/04/2004
  TabControl1Change(Sender); // pour configuer les boutons
  if (pItem)
    pItem->MakeVisible(false); // 29/05/2004
}
//---------------------------------------------------------------------------
// Affiche le nombre de rejets
void __fastcall TFormRejets::NombreRejets()
{
DEBUG_LINE
	LblNbrRejets->Caption = LoadStr(3019) + IntToStr(ListeHist->Items->Count);
	LblNbrRejets->Visible = ListeHist->Items->Count;
}
//---------------------------------------------------------------------------
// Bouton Supprimer
void __fastcall TFormRejets::BtnSupprClick(TObject *Sender)
{
DEBUG_LINE
TListItem *pItem;
AnsiString Achaine;
	BtnSuppr->Tag = 0; // 03/07/2005
	if (Liste[TabControl1->TabIndex]->SelCount > 1) // 03/07/2005
	{
		Achaine.sprintf(LoadStr(3051).c_str(), Liste[TabControl1->TabIndex]->SelCount);
		BtnSuppr->Tag = Forms::Application->MessageBox(Achaine.c_str(), LoadStr(3021).c_str(),
																				MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDYES;
	}
	for (int i = 0 ; i < Liste[TabControl1->TabIndex]->Items->Count ; i++) // 01/04/2005
	{
    pItem = Liste[TabControl1->TabIndex]->Items->Item[i];
    if (pItem->Selected)
    {
      AnsiString As = LoadStr(3020) + pItem->Caption + "' ?";
      if (BtnSuppr->Tag || Forms::Application->MessageBox(As.c_str(), LoadStr(3021).c_str(),
																				MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDYES)
      {
        pItem->Delete();
        i--; // 03/04/2005
				Liste[TabControl1->TabIndex]->Tag = 1;
        TabControl1Change(this); // pour configuer les boutons
			}
    }
  }
	Liste[TabControl1->TabIndex]->SetFocus();
}
//---------------------------------------------------------------------------
// Bouton Modifier
void __fastcall TFormRejets::BtnModifClick(TObject *Sender)
{
DEBUG_LINE
TListItem *pItem;
AnsiString As;
int  iAvant = -1, inc = 0, EstDest = (TabControl1->TabIndex == 2);
	Liste[TabControl1->TabIndex]->SetFocus();
	if (!Liste[TabControl1->TabIndex]->Selected)
		return;
	Form6->RadioButtonRejeter->Checked = true;
	Form6->Label1->Caption = "&" + Form6Label1Caption(); // 14/05/2006
	pItem = Liste[TabControl1->TabIndex]->Selected;
  As = pItem->Caption;
  if (As[1] == '' || As[1] == '' || As[1] == '~')
  {
    Form6->EditType->Text = As[1];
    Form6->Edit1->Text = As.Delete(1,1);
  }
  else
	{
    Form6->EditType->Text = "";
    Form6->Edit1->Text = As;
  }
  if (pItem->Caption.AnsiPos("*") == 0 && pItem->Caption.AnsiPos("?") == 0 &&
        pItem->Caption.AnsiPos("#") == 0 && pItem->Caption.AnsiPos("") == 0) // 11/06/2004
	Form6->Edit2->Text = pItem->Caption.SubString(
				(pItem->Caption[1] == '' || pItem->Caption[1] == '' || pItem->Caption[1] == '~') + 1, 255);
  else
		Form6->Edit2->Text = "";
  if (pItem->Caption[1] == '~')
    Form6->RadioGroupType->ItemIndex = 3;
  else if (pItem->Caption[1] == '')
    Form6->RadioGroupType->ItemIndex = 2;
  else Form6->RadioGroupType->ItemIndex = pItem->Caption[1] == '';
  if (EstDest) // Destinataire
  {
    try
    {
      for (int j = 0 ; j < sizeof(cDest)/sizeof(char) ; j++)
        if (pItem->SubItems->Strings[0][1] == cDest[j])
        {
          iAvant = j;
          break;
				}
    }
    catch (Exception &exception)
    {
			iAvant = 0;
    }
		Form6->RadioGroupDest->ItemIndex = iAvant;
    inc = 1; // Cause colonne supplmentaire pour Destinataire
  }
  iAvant = 2; // Garder par dfaut
  for (int j = 0 ; j < sizeof(cAvant)/sizeof(char) ; j++) //Groupe Avant d'effectuer le rejet
    if ((pItem->SubItems->Strings[inc][1] | 32) == (cAvant[j] | 32) ) // minuscule
    {
      iAvant = j;
      break;
		}
	Form6->RadioGroupAvant->ItemIndex = iAvant;
  try
  {
    for (int j = 0 ; j < sizeof(cExecuter)/sizeof(char) ; j++) // Groupe Excuter (Rponse)
      if (pItem->SubItems->Strings[inc+1][1] == cExecuter[j])
			{
				iAvant = j;
        break;
      }
  }
  catch (Exception &exception)
  {
    iAvant = 0;
	}
  Form6->RadioGroupReponse->ItemIndex = iAvant;
  try
  {
    for (int j = 0 ; j < sizeof(cInclure)/sizeof(char) ; j++)//Groupe Inclure dans la rponse
      if (pItem->SubItems->Strings[inc+1][2] == cInclure[j])
      {
        iAvant = j;
        break;
			}
  }
	catch (Exception &exception)
  {
    iAvant = 0;
  }
  Form6->RadioGroupInclure->ItemIndex = iAvant;
  Form6->RadioGroupInclure->Enabled = Form6->RadioGroupReponse->ItemIndex;
  Form6->RadioButtonAccepter->Checked = pItem->ImageIndex;
//	Form6->Caption = LoadStr(3037);
	Form6->Caption = LoadStr(3037) + Form6Label1Caption(); // 14/05/2006
	Form6->ShowModal();
  if (Form6->ModalResult == mrOk)
  {
    inc = 0;
		if (pItem->Caption != Form6->EditType->Text + Form6->Edit1->Text)
		{
			if (Form6->Edit1->Text != As) // 23/12/2004
        if (TesteRejetExiste())
          return;
      if (pItem->SubItems->Count > (2 + EstDest)) // 14/06/2004
				pItem->SubItems->Strings[2 + EstDest] = " "; // Compteur  zro 11/06/2004
    }
		pItem->Caption = Form6->EditType->Text + Form6->Edit1->Text;
    if (EstDest) // Destinataire
      pItem->SubItems->Strings[inc++] = cDest[Form6->RadioGroupDest->ItemIndex];
    pItem->SubItems->Strings[inc] = Form6->RadioButtonRejeter->Checked == true ?
								cAvant[Form6->RadioGroupAvant->ItemIndex] : ' ';
    if (Form6->RadioButtonRejeter->Checked)
    {
      As = cExecuter[Form6->RadioGroupReponse->ItemIndex];
			if (Form6->RadioGroupReponse->ItemIndex == 0) // Ne pas rpondre
        As += " ";
      else
        As += cInclure[Form6->RadioGroupInclure->ItemIndex];
    }
    else
      As = " ";
    pItem->SubItems->Strings[inc+1] = As;
		pItem->ImageIndex = Form6->RadioButtonAccepter->Checked;
		Liste[TabControl1->TabIndex]->Tag = 1;
		Liste[TabControl1->TabIndex]->SortDirection = sdAscending; // 31/05/2004
		Liste[TabControl1->TabIndex]->SortColumn = 0; // 31/05/2004
		pItem->MakeVisible(false); // 29/05/2004
	}
}
//---------------------------------------------------------------------------
// Bouton Excel
void __fastcall TFormRejets::BtnExcelClick(TObject *Sender)
{
DEBUG_LINE
	PopupMenu2->Popup(Mouse->CursorPos.x, Mouse->CursorPos.y);
}
//---------------------------------------------------------------------------
// Bouton Recherche
void __fastcall TFormRejets::BtnRechClick(TObject *Sender)
{
DEBUG_LINE
bool OrigHist = dynamic_cast<TAdvListView *>(Sender) == ListeHist; // menu "Trouver" depuis ListeHist
	if (!OrigHist)  // 04/12/2004
    Liste[TabControl1->TabIndex]->SetFocus();
  if (!Liste[TabControl1->TabIndex]->Items->Count)
		return;
  if (!Liste[TabControl1->TabIndex]->SelCount)
  {
    Liste[TabControl1->TabIndex]->Selected = NULL; // 07/07/2005
    Liste[TabControl1->TabIndex]->SelectItem(0);
  }
  do
  {
    if (dynamic_cast<TBitBtn *>(Sender) == BtnRech || AsRech == "")
      if (!InputQuery(LoadStr(3022), LoadStr(3023), AsRech))
        return;
    if (AsRech != "")
		{
      AsRech = AsRech.LowerCase();
			for (int i = min(Liste[TabControl1->TabIndex]->Selected->Index + (int)(OrigHist == false),
                                        Liste[TabControl1->TabIndex]->Items->Count - 1) ;
																				i < Liste[TabControl1->TabIndex]->Items->Count ; i++)
      {
				if(Liste[TabControl1->TabIndex]->Items->Item[i]->Caption.LowerCase().AnsiPos(AsRech)
                                                                   || RechSubItem(i, AsRech))
        {
          Liste[TabControl1->TabIndex]->Selected = NULL; // 07/07/2005
          Liste[TabControl1->TabIndex]->SelectItem(i);
          return;
        }
      }
    }
  }
  while (AsRech == "");
  if (OrigHist) // 04/12/2004
    ShowMessage("\"" + AsRech + LoadStr(3049)); // " n'existe plus"
  else
    Liste[TabControl1->TabIndex]->SetFocus();
}
//---------------------------------------------------------------------------
// Continue la recherche dans les SubItems des listes
bool __fastcall TFormRejets::RechSubItem(int Index, AnsiString AsRech2)
{
DEBUG_LINE
int n = Liste[TabControl1->TabIndex]->Columns->Count;
	for (int i = 0 ; i < n-1 ; i++)
		try
		{
			if (Liste[TabControl1->TabIndex]->Items->Item[Index]->SubItems->Strings[i].LowerCase().AnsiPos(AsRech2))
				return true;
		}
		catch (Exception &exception)
		{
			;
		}
	return false;
}
//---------------------------------------------------------------------------
// Bouton Impr
void __fastcall TFormRejets::BtnImprClick(TObject *Sender)
{
DEBUG_LINE
	if (Forms::Application->MessageBox(LoadStr(3024).c_str(), LoadStr(3025).c_str(),
																MB_YESNO | MB_DEFBUTTON1) ==IDNO)
		return;
	Liste[TabControl1->TabIndex]->OnDrawItemProp = NULL;
	Liste[TabControl1->TabIndex]->Print();
	Liste[TabControl1->TabIndex]->OnDrawItemProp = ListeAdrDrawItemProp;
}
//---------------------------------------------------------------------------
// Bouton met  zro les compteurs de rejets
void __fastcall TFormRejets::Btn0rejetClick(TObject *Sender)
{
DEBUG_LINE
int s = (TabControl1->TabIndex == 2);
	if (Forms::Application->MessageBox(LoadStr(3026).c_str(), LoadStr(3027).c_str(),
                                        MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDYES)
  {
    TListItems * TLI = Liste[TabControl1->TabIndex]->Items;
		for (int i = 0 ; i < TLI->Count ; i++)
      if (TLI->Item[i]->SubItems->Count > (s + 2))
				TLI->Item[i]->SubItems->Strings[s + 2] = "0";
    Liste[TabControl1->TabIndex]->Tag = 1;
  }
}
//---------------------------------------------------------------------------
// Bouton Fermer
void __fastcall TFormRejets::BtnFermerClick(TObject *Sender)
{
DEBUG_LINE
	if (GetKeyState(VK_MENU) & 0x80) // <Alt> 12/11/2004
		Fermeture();
	FormRejets->Visible = false;
	if (TabControl1->TabIndex == 5) // Histo
		FermerHisto();
// Restaurer les valeurs d'origine
}
//---------------------------------------------------------------------------
// Clic dans une liste
void __fastcall TFormRejets::ListeAdrClick(TObject *Sender)
{
DEBUG_LINE
	int i = Liste[TabControl1->TabIndex]->Selected && true;
	Supprimeruneadresse1->Enabled = i;
	Modifieruneadresse1->Enabled = i & Liste[TabControl1->TabIndex]->SelCount == 1;
	BtnSuppr->Enabled = i;
	BtnModif->Enabled = i & Liste[TabControl1->TabIndex]->SelCount == 1;
}
//---------------------------------------------------------------------------
// Menu Export Excel
void __fastcall TFormRejets::ExporterauformatExcel1Click(TObject *Sender)
{
DEBUG_LINE
	SaveDialog1->FileName = "*.xls";
	if (SaveDialog1->Execute())
	{
		try
		{
			Liste[TabControl1->TabIndex]->SaveToXLS(SaveDialog1->FileName);
		}
		catch (Exception &exception)
		{
			ShowMessage(LoadStr(3028));
			Beep();
			Screen->Cursor = crDefault;
		}
	}
}
//---------------------------------------------------------------------------
// Menu Import Excel
void __fastcall TFormRejets::ImporterauformatExcel1Click(TObject *Sender)
{
DEBUG_LINE
TListColumns *Colonne;
int Largeur[5];
AnsiString Libelle[5];
  if (!Liste[TabControl1->TabIndex]->Items->Count ||
              Forms::Application->MessageBox(LoadStr(3029).c_str(), LoadStr(3030).c_str(),
																			 MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDOK)
  {
		OpenDialog1->FileName = "*.xls";
    OpenDialog1->DefaultExt = "xls";
    OpenDialog1->Filter = LoadStr(3031);
    OpenDialog1->Title = LoadStr(3032);
    if (OpenDialog1->Execute())
    {
      Screen->Cursor = crHourGlass;
      Colonne = Liste[TabControl1->TabIndex]->Columns;
      int n = Colonne->Count;
      for (int i = 0 ; i < n ; i++)
      {
        Largeur[i] = Colonne->Items[i]->Width;
        Libelle[i] = Colonne->Items[i]->Caption;
      }
      Liste[TabControl1->TabIndex]->LoadFromXLS(OpenDialog1->FileName);
			for (int i = 0 ; i < n ; i++)
      {
        Colonne->Items[i]->Width = Largeur[i];
        Colonne->Items[i]->Caption = Libelle[i];
      }
      while (Colonne->Count > n)
        Colonne->Delete(n);

// Positionne le symbole Ami/rejet 24/04/2004
      TListItem *pItem;
      int c = Liste[TabControl1->TabIndex]->Columns->Count - 2;
      for (int i = 0 ; i < Liste[TabControl1->TabIndex]->Items->Count ; i++)
      {
        pItem = Liste[TabControl1->TabIndex]->Items->Item[i];
        try
        {
          pItem->ImageIndex = pItem->SubItems->Strings[c] == 'A';
        }
        catch(...) {;}
			}

      Liste[TabControl1->TabIndex]->Tag = 1;
      BtnRech->Enabled = Liste[TabControl1->TabIndex]->Items->Count;
      BtnImpr->Enabled = BtnRech->Enabled;
      ExporterauformatExcel1->Enabled = BtnRech->Enabled;
      Screen->Cursor = crDefault;
    }
  }
}
//---------------------------------------------------------------------------
// Gestion manuelle du clavier
void __fastcall TFormRejets::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
DEBUG_LINE
bool Ctrl = Shift.Contains(ssCtrl);
	switch (Key) {
		case VK_F1 :
			Form1->Aide(LoadStr(30001)); break;
		case VK_DELETE :
			if (TabControl1->TabIndex <= 2) BtnSupprClick(this);
      break;
		case VK_INSERT :
      if (TabControl1->TabIndex <= 2) BtnCreerClick(this);
      break;
    case VK_RETURN :
      if (TabControl1->TabIndex <= 2) BtnModifClick(this);
      break;
    case VK_ESCAPE :
			BtnFermerClick(this);
    case 'F' :
      if (Ctrl) BtnRechClick(BtnRech); break;
    case VK_F3 :
      BtnRechClick(Sender); break;
    case VK_PRIOR :
      if (Ctrl)
      {
        if (TabControl1->TabIndex == 0)
          TabControl1->TabIndex = TabControl1->Tabs->Count - 1;
        else
          TabControl1->TabIndex--;
        TabControl1Change(Sender);
      }
      break;
		case VK_NEXT :
      if (Ctrl)
      {
        if (TabControl1->TabIndex == TabControl1->Tabs->Count - 1)
          TabControl1->TabIndex = 0;
        else
          TabControl1->TabIndex++;
        TabControl1Change(Sender);
      }
      break;
  }
}
//---------------------------------------------------------------------------
// Selection d'un Item dans une liste
void __fastcall TFormRejets::ListeAdrSelectItem(TObject *Sender, TListItem *Item,
																																				bool Selected)
{
DEBUG_LINE
	if (TabControl1->TabIndex != 3 && TabControl1->TabIndex != 4) // peut survenir quand on change d'onglet
		ListeAdrClick(Sender);
}
//---------------------------------------------------------------------------
// Appel depuis Form1  la fermeture du programme ou si <Alt> + "Fermer"
void __fastcall TFormRejets::Fermeture()
{
DEBUG_LINE
AnsiString Fic, Fic2, Fic3, Fic4;
TListItem *pItem;
int c, i, j ,k;

	SetCurrentDir(ExtractFilePath(Forms::Application->ExeName)); // 28/10/2004
	Form1->AfficheSB(0, LoadStr(3033));
	for (i = 0 ; i < 3 ; i++) // pour chaque liste de filtres
	{
		c = Liste[i]->Columns->Count - 2; // indice du dernier SubItem (dernires colonne)
		for (j = 0 ; j < Liste[i]->Items->Count ; j++) // pour chaque ligne
		{
			pItem = Liste[i]->Items->Item[j];
			for (k = pItem->SubItems->Count - 1 ; k < c ; k++)
				pItem->SubItems->Add("");
			pItem->SubItems->Strings[c] = pItem->ImageIndex == 1 ? "A" : "R";
		}
	}
	if (!DirectoryExists(LoadStr(3034))) // ".\\sauv\\"
		CreateDir(LoadStr(3034));
	for (int i = 0 ; i < 6 ; i++)
	{
		if (Liste[i] && Liste[i]->Tag)
		{
			Fic = ChangeFileExt(Forms::Application->ExeName, Extension[i]);
			if (Liste[i]->Items->Count)
			{
				if (i == 5) // Historique
				{
					ListeHist->SortDirection = sdDescending;
					ListeHist->SortColumn = 0; // DateHeure
				}
				if (FileExists(Fic)) // alors sauvegarder
				{
					Fic2 = LoadStr(3034) + ExtractFileName(Fic);
					try
					{
						for (int f = Form1->iNbSauv ; f > 1 ; f--) // 10/07/2005
						{
							Fic3 = Fic2 + IntToStr(f);
							Fic4 = Fic2 + IntToStr(f - 1);
							if (f == Form1->iNbSauv && FileExists(Fic3))
								DeleteFile(Fic3.c_str());
							if (FileExists(Fic4))
								MoveFile(Fic4.c_str(), Fic3.c_str());
            }
            if (FileExists(Fic2)) // .\sauv\OutClock.rej
              MoveFile(Fic2.c_str(), (Fic2 + "1").c_str());
					}
          __finally
          {
            CopyFile(Fic.c_str(), Fic2.c_str(), false);
          }
				}
FILE *out;
AnsiString As;
				if ((out = fopen(Fic.c_str(), "wt")) != NULL) // 23/10/2004
        {
					for (j = 0 ; j < Liste[i]->Items->Count ; j++)
					{
            pItem = Liste[i]->Items->Item[j];
            As = pItem->Caption + ",";
            for (k = 0 ; k < Liste[i]->Columns->Count - 1 ; k++)
						{
              if (k < pItem->SubItems->Count) // 24/10/2004
								As += pItem->SubItems->Strings[k];
              if (k < Liste[i]->Columns->Count - 2)
                As += ",";
              else
                As += "\n";
            }
            fputs(As.c_str(), out);
          }
          fclose(out);
        }
      }
      else
        DeleteFile(Fic); // liste vide
      Liste[i]->Tag = 0; // la sauvegarde n'est plus  faire
		}
  }
  if (FormRejets->Tag) // Form a t active 28/01/2004
  {
    Form1->ini->WriteInteger(NOM_APPLI, "RejTop",    FormRejets->Top);
    Form1->ini->WriteInteger(NOM_APPLI, "RejLeft",   FormRejets->Left);
    Form1->ini->WriteInteger(NOM_APPLI, "RejHeight", FormRejets->Height);
		Form1->ini->WriteInteger(NOM_APPLI, "RejWidth",  FormRejets->Width);
	}

// sauvegarde de OutClock.ini 07/01/2008
	Fic = ChangeFileExt(Forms::Application->ExeName, ".ini");
	Fic2 = LoadStr(3034) + ExtractFileName(Fic);
	try
	{
		for (int f = Form1->iNbSauv ; f > 1 ; f--) // 10/07/2005
		{
			Fic3 = Fic2 + IntToStr(f);
			Fic4 = Fic2 + IntToStr(f - 1);
			if (f == Form1->iNbSauv && FileExists(Fic3))
				DeleteFile(Fic3.c_str());
			if (FileExists(Fic4))
				MoveFile(Fic4.c_str(), Fic3.c_str());
		}
		if (FileExists(Fic2)) // .\sauv\OutClock.ini
			MoveFile(Fic2.c_str(), (Fic2 + "1").c_str());
	}
	__finally
	{
		CopyFile(Fic.c_str(), Fic2.c_str(), false);
	}
// FIN sauvegarde de OutClock.ini

  Form1->AfficheSB(0, LoadStr(3050));
}
//---------------------------------------------------------------------------
// Ne pas modifier la slection dans les listes si Ctrl + PgUp ou PgDw
void __fastcall TFormRejets::ListeKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
DEBUG_LINE
	if (Shift.Contains(ssCtrl) && (Key == VK_NEXT || Key == VK_PRIOR))
		Key = NULL;
}
//---------------------------------------------------------------------------
// Insre un fichier CSV
void __fastcall TFormRejets::InsererCSVRejetsClick(TObject *Sender)
{
DEBUG_LINE
TListItem *pItem;
int c, k;
char *Ch;
  OpenDialog1->FileName = "*.*";
  OpenDialog1->DefaultExt = "";
  OpenDialog1->Filter = LoadStr(3035);
  OpenDialog1->Title = LoadStr(3036);
  if (OpenDialog1->Execute())
  {
    Screen->Cursor = crHourGlass;
    Liste[TabControl1->TabIndex]->InsertFromCSV(OpenDialog1->FileName);
    Liste[TabControl1->TabIndex]->Tag = 1;
    BtnRech->Enabled = Liste[TabControl1->TabIndex]->Items->Count;
		BtnImpr->Enabled = BtnRech->Enabled;
    ExporterauformatExcel1->Enabled = BtnRech->Enabled;
    Screen->Cursor = crDefault;
		c = Liste[TabControl1->TabIndex]->Columns->Count - 2;
		TMenuItem *MenuItem = dynamic_cast<TMenuItem *>(Sender);
    char ar = MenuItem == InsererCSVRejets ? 'R' : 'A';
		for (int i = 0 ; i < Liste[TabControl1->TabIndex]->Items->Count ; i++)
    {
      pItem = Liste[TabControl1->TabIndex]->Items->Item[i];
      for (k = pItem->SubItems->Count - 1 ; k < c ; k++)
        pItem->SubItems->Add(" ");
			if (pItem->ImageIndex == -1) // vient d'tre import
      {
        pItem->SubItems->Strings[c] = ar;
        pItem->ImageIndex = ar == 'A';
        Ch = pItem->SubItems->Strings[c-3].c_str();
        if (*Ch == ' ' || *Ch == 'm')
					*Ch = 'g';
        if (*Ch == 'D')
          *Ch = 'd';
        if (pItem->SubItems->Strings[c-2] == " ")
          pItem->SubItems->Strings[c-2] = "N ";
        if (TabControl1->TabIndex == 2) // Destinataire
          pItem->SubItems->Strings[0] = 'L';
      }
    }
  }
}
//---------------------------------------------------------------------------
//---------------------------- Onglet Inexistant ----------------------------
void __fastcall TFormRejets::CheckBoxRejeterInexClick(TObject *Sender)
{
DEBUG_LINE
	ConditionsRejetInex->Enabled = CheckBoxRejeterInex->Checked;
	RadioGroupAvantInex->Enabled = CheckBoxRejeterInex->Checked;
	GroupBoxDNS->Enabled = CheckBoxRejeterInex->Checked;
	BtnTestDNS->Enabled = CheckBoxRejeterInex->Checked;
	Label13->Enabled = CheckBoxRejeterInex->Checked;
	Label14->Enabled = CheckBoxRejeterInex->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TFormRejets::BtnTestDNSClick(TObject *Sender)
{
DEBUG_LINE
AnsiString As;
	if (!Form1->TesteInternet())
	{
		ShowMessage(LoadStr(3038)); // Test impossible :\r\nPas de connexion Internet active
		return;
	}
	if ((As = Form1->GetDNS()) != "")
		ShowMessage(LoadStr(3039) + As + LoadStr(3040)); // Un DNS a t trouv automatiquement : ... \r\nLa zone doit donc rester vide
	else
		ShowMessage(LoadStr(3041)); // Aucun DNS trouv. Il faut remplir la zone requise
}
//---------------------------------------------------------------------------
// Bouton Aide de PanelBas
void __fastcall TFormRejets::BtnAideClick(TObject *Sender)
{
DEBUG_LINE
	if (TabControl1->TabIndex == 5)
		Form1->Aide(LoadStr(30002));
	else
		Form1->Aide(LoadStr(30001));
}
//---------------------------------------------------------------------------
void __fastcall TFormRejets::BtnAideInexClick(TObject *Sender)
{
DEBUG_LINE
	Form1->Aide(LoadStr(30003));
}
//---------------------------------------------------------------------------
void __fastcall TFormRejets::BtnAideRepClick(TObject *Sender)
{
DEBUG_LINE
	Form1->Aide(LoadStr(30004));
}
//---------------------------------------------------------------------------
// Menu Popup de la liste Historique
void __fastcall TFormRejets::PopupHistPPPopup(TObject *Sender)
{
DEBUG_LINE
	lexpditeur1->Enabled = ListeHist->Selected;
	Lesujet1->Enabled = lexpditeur1->Enabled;
	Ledestinataireprincipal1->Enabled = lexpditeur1->Enabled;
	Ledestinataireencopie1->Enabled = lexpditeur1->Enabled;
}
//---------------------------------------------------------------------------
// Clic dans une option du menu de ListeHist
void __fastcall TFormRejets::lexpditeur1Click(TObject *Sender)
{
DEBUG_LINE
AnsiString As;
int Lgr;
TMenuItem *ClickedItem = dynamic_cast<TMenuItem *>(Sender);
  try
  {
    TListItem *pItem = ListeHist->Items->Item[ListeHist->Selected->Index];
    As = pItem->SubItems->Strings[ClickedItem->HelpContext];
    Lgr = As.Length();
    if (As[Lgr] == '\x0A0' || As[Lgr] == '\x0B7' || As[Lgr] == ' ')
			As.Delete(Lgr, 1);
    Clipboard()->Open();
    Clipboard()->SetTextBuf(As.c_str()); // 27/12/2003
    Clipboard()->Close();
  }
  catch(...) // au cas o le champ n'existe pas
  {
    Beep();
  }
}
//---------------------------------------------------------------------------
// Gre les minima des lignes historique 08/02/2004
void __fastcall TFormRejets::Edit7Exit(TObject *Sender)
{
DEBUG_LINE
	Edit7->Text = UpDown1->Position;
	Edit6->Text = UpDown2->Position;
}
//---------------------------------------------------------------------------
// Evnement pour choisir le type tri des listes derejets 29/02/2004
void __fastcall TFormRejets::ListeAdrGetFormat(TObject *Sender, int ACol,
			TSortStyle &AStyle, AnsiString &aPrefix, AnsiString &aSuffix)
{
DEBUG_LINE
	if (ACol == Liste[TabControl1->TabIndex]->Columns->Count - 3) // nombre de rejets
		AStyle = ssNumeric;
	else
		AStyle = ssAlphaNoCase;
}
//---------------------------------------------------------------------------
// Initialise la position de la fentre
void __fastcall TFormRejets::PosIni()
{
DEBUG_LINE
	FormRejets->Top    = Form1->ini->ReadInteger(NOM_APPLI, "RejTop", 10);
	FormRejets->Left   = Form1->ini->ReadInteger(NOM_APPLI, "RejLeft", 10);
	FormRejets->Height = Form1->ini->ReadInteger(NOM_APPLI, "RejHeight", 478);
	FormRejets->Width  = Form1->ini->ReadInteger(NOM_APPLI, "RejWidth", 640);
}
//---------------------------------------------------------------------------
// Teste qu'un rejet n'existe pas dj
bool __fastcall TFormRejets::TesteRejetExiste() // 20/03/2004
{
DEBUG_LINE
AnsiString As;
	for (int r = 0 ; r < Liste[TabControl1->TabIndex]->Items->Count ; r++) // Liste des items  rejeter
	{
    As = Liste[TabControl1->TabIndex]->Items->Item[r]->Caption ; // 22/12/2004
    if (As[1] == '' || As[1] == '' || As[1] == '~') // 22/12/2004
      As.Delete(1, 1);
    if (Form6->Edit1->Text == As)
//                Liste[TabControl1->TabIndex]->Items->Item[r]->Caption)
    {
      Beep();
			Liste[TabControl1->TabIndex]->Selected = NULL; // 07/07/2005
      Liste[TabControl1->TabIndex]->SelectItem(r);  // 22/12/2004
      ShowMessage("\"" + Form6->Edit1->Text + LoadStr(3018));
      return true; // existe
    }
	}
  return false; // n'existe pas
}
//---------------------------------------------------------------------------
// Lecture d'un fichier de filtres 19/10/2004
void __fastcall TFormRejets::OuvreFic(int i, AnsiString Fic)
{
DEBUG_LINE
TListItem *pItem;
FILE *in;
char szChaine[1023], szListeItem[1023], *ptr;
TStringList *AsListe = new TStringList;
int k;
AnsiString As;

  if ((in = fopen(Fic.c_str(), "rt")) != NULL)
	{
    while (!feof(in))
    {
      if (fgets(szChaine, 1022, in))
			{
        if (*szChaine == '\r' || *szChaine == '\n')
					continue; // ligne vide
        if (i == 5 && (*szChaine < '0' || *szChaine > '9')) // ligne historique trop longue
          continue;
        ptr = szChaine;
        k = 0;
        AsListe->Clear();
        pItem = Liste[i]->Items->Add();
        while (*ptr != '\0' && *ptr != '\r' && *ptr != '\n')
        {
          while (*ptr != ',' && *ptr != '\0' && *ptr != '\r' && *ptr != '\n')
            szListeItem[k++] = *ptr++;
          szListeItem[k] = '\0';
          AsListe->Add(szListeItem);
          if (*ptr == ',')
          {
            ptr++;
            k = 0;
          }
        }
        pItem->Caption = AsListe->Strings[0];
        for (k = 0 ; k < (Liste[i]->Columns->Count - 1) ; k++)
        {
          if (k < (AsListe->Count - 1))
            pItem->SubItems->Add(AsListe->Strings[k + 1]);
          else
            pItem->SubItems->Add("");
        }
        if (i != 5) // diffrent de historique
				{
          if (i == 2) // liste destinataires
          {
            As = pItem->SubItems->Strings[0];
            if (As != "A" && As != "C" && As != "L")
              pItem->SubItems->Strings[0] = "A";
					}
          As = pItem->SubItems->Strings[3 + (int)(i == 2)];
          if (As == "A") // ami
            pItem->ImageIndex = 1;
          else // rejet
          {
            if (As != "R")
            {
              pItem->SubItems->Strings[3 + (int)(i == 2)] = "R";
              Liste[i]->Tag = 1;
           }
            As = pItem->SubItems->Strings[(int)(i == 2)]; // Colonne "Avant"
						if (As != "R" && As != "d" && As != "g" && As != "c") // 07/10/2007 pour le 'c'
						{
							pItem->SubItems->Strings[(int)(i == 2)] = "g";
							Liste[i]->Tag = 1;
            }
            As = pItem->SubItems->Strings[1 + (int)(i == 2)]; // Colonne "Pendant"
            if (As == "" || (As != "N " && As[1] != 'o' && As[1] != 'v' && As[1] != 's')) // As[1] : 02/01/2005
						{
              pItem->SubItems->Strings[1 + (int)(i == 2)] = "N ";
							Liste[i]->Tag = 1;
            }
            As = pItem->SubItems->Strings[2 + (int)(i == 2)]; // Colonne "Nb Rejets"
            if (As != "")
            {
							try
              {
                StrToInt(As);
              }
              catch(...)
              {
                pItem->SubItems->Strings[2 + (int)(i == 2)] = "";
								Liste[i]->Tag = 1;
              }
            }
          }
        }
      }
    }
    fclose(in);
  }
  delete AsListe;
}
//---------------------------------------------------------------------------
// clic droit sur une ligne historique 02/12/2004
void __fastcall TFormRejets::ListeHistRightClickCell(TObject *Sender, int iItem, int iSubItem)
{
DEBUG_LINE
int i, j;
	AsFiltre = "";
	Trouverlefiltre1->Enabled = false;
	Trouverlefiltre1->Caption = LoadStr(3048); // "Trouver "
	if (ListeHist->Selected && iSubItem > 0) // ailleurs que dans la colonne date 05/12/2004
	{
		AnsiString As = ListeHist->Items->Item[iItem]->SubItems->Strings[iSubItem-1];
		while ((i =  As.Length()) > 1 && As[i] != ')' )
			As.Delete(i--, 1);
		if (i >= 2)  // la ligne se termine par un filtre
		{
			j = i;
			for (; i > 1 && As[i] != '(' ; i--);
			AsFiltre = As.SubString(i+1, j-i-1);
			HistFiltreTrouve = min(iSubItem - 1, 2); // min : cause DestCc
			if (AsFiltre != "")
			{
				Trouverlefiltre1->Enabled = true;
				Trouverlefiltre1->Caption = LoadStr(3048) + AsFiltre; // pour le calcul automatique de la largeur du menu
			}
		}
	}
	PopupHistPP->Popup(Mouse->CursorPos.x, Mouse->CursorPos.y);
}
//---------------------------------------------------------------------------
// Menu PopUp historique "Trouver le filtre" 02/12/2004
void __fastcall TFormRejets::Trouverlefiltre1Click(TObject *Sender)
{
DEBUG_LINE
	AsRech = AsFiltre;
	TabControl1->TabIndex = HistFiltreTrouve;
	TabControl1Change(Sender);
	Liste[TabControl1->TabIndex]->Selected = NULL; // 07/07/2005
	Liste[TabControl1->TabIndex]->SelectItem(0);
	BtnRechClick(ListeHist);
}
//---------------------------------------------------------------------------
// OwnerDraw du Menu PoPup Histo 04/12/2004
void __fastcall TFormRejets::CopierPPHistoTitreDrawItem(TObject *Sender,
			TCanvas *ACanvas, TRect &ARect, bool Selected)
{
DEBUG_LINE
	ACanvas->Brush->Color = clActiveCaption;
  ACanvas->FillRect(ARect);
  ACanvas->Font->Style = TFontStyles() << fsItalic;
  ACanvas->Font->Color = clCaptionText;
  ACanvas->TextOut(ARect.left+6, ARect.top+3, CopierPPHistoTitre->Caption.SubString(2,255));
}
//---------------------------------------------------------------------------
// OwnerDraw du Menu PoPup Histo 03/12/2004
void __fastcall TFormRejets::Trouverlefiltre1DrawItem(TObject *Sender,
			TCanvas *ACanvas, TRect &ARect, bool Selected)
{
DEBUG_LINE
	if (Trouverlefiltre1->Enabled == false)
		ACanvas->Font->Color = clGrayText;
	if (Selected) // 04/12/2004
		ACanvas->Brush->Color = clHighlight;
	else
		ACanvas->Brush->Color = clMenu;
	ACanvas->FillRect(ARect);
	ACanvas->TextOut(ARect.left + 6, ARect.top + 3, LoadStr(3048)); // "Trouver "
	ACanvas->Font->Color = clRed;
	ACanvas->TextOut(ACanvas->PenPos.x, ARect.top + 3, AsFiltre);
}
//---------------------------------------------------------------------------
// Changement BR From / ReturnPath 05/05/2006
void __fastcall TFormRejets::GroupFromReturnPathClick(TObject *Sender)
{
DEBUG_LINE
	if (Form1->ListView1->Columns->Items[1]->Caption != LoadStr(10011 +GroupFromReturnPath->ItemIndex))

		if (GroupFromReturnPath->Tag == -1  ||  // dmarrage d'OutClock 13/05/2006
					Forms::Application->MessageBox(LoadStr(1111).c_str(), LoadStr(1112).c_str(),
																					MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDYES)
		{
			Form1->ListView1->Columns->Items[1]->Caption=LoadStr(10011+GroupFromReturnPath->ItemIndex);
			GroupFromReturnPath->Tag = GroupFromReturnPath->ItemIndex;
		}
		else
			GroupFromReturnPath->ItemIndex = GroupFromReturnPath->Tag;
}
//---------------------------------------------------------------------------
// Mmorise l'ancienne valeur de GroupFromReturnPath->ItemIndex
void __fastcall TFormRejets::GroupFromReturnPathEnter(TObject *Sender)
{
DEBUG_LINE
	GroupFromReturnPath->Tag = GroupFromReturnPath->ItemIndex;
}
//---------------------------------------------------------------------------
// Nature du filtre  crer/modifier
AnsiString  __fastcall TFormRejets::Form6Label1Caption()  // 14/05/2006
{
DEBUG_LINE
	switch (TabControl1->TabIndex) {
		case 0 : return (LoadStr(3051) + LoadStr(10011 + GroupFromReturnPath->ItemIndex));
		default : return (LoadStr(3001 + TabControl1->TabIndex));
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormRejets::GarderDetruire() // 27/05/2005
{
DEBUG_LINE
AnsiString Chaine;
int ItemIndexCombo;
	Chaine.sprintf(LoadStr(6014).c_str(), Form1->DelaiRejeterGarder, Form1->DelaiRejeterGarder);
	ItemIndexCombo = ComboBoxSujetVide->ItemIndex;
	ComboBoxSujetVide->Items->Text = Chaine;
	ComboBoxSujetVide->ItemIndex = ItemIndexCombo;
	ItemIndexCombo = ComboBoxDestA->ItemIndex;
	ComboBoxDestA->Items->Text = Chaine;
	ComboBoxDestA->ItemIndex = ItemIndexCombo;
	ItemIndexCombo = ComboBoxPasArobase->ItemIndex;
	ComboBoxPasArobase->Items->Text = Chaine;
	ComboBoxPasArobase->ItemIndex = ItemIndexCombo;
}
//---------------------------------------------------------------------------
// Clic dans CheckBox d'authentifacation SMTP
void __fastcall TFormRejets::CheckBoxAuthClick(TObject *Sender)
{
DEBUG_LINE
	Label26->Enabled = CheckBoxAuth->Checked;
	ComboSMTPPort->Enabled = CheckBoxAuth->Checked;
	if (!CheckBoxAuth->Checked)
		ComboSMTPPort->ItemIndex = 0; // port 25
}
//---------------------------------------------------------------------------
// Changement de port SMTP
void __fastcall TFormRejets::ComboSMTPPortChange(TObject *Sender) // 24/07/2007
{
DEBUG_LINE
	if (ComboSMTPPort->ItemIndex == 1) // Port 587
		EditAuthMdP->SetFocus();
}
//---------------------------------------------------------------------------
bool __fastcall TFormRejets::Teste587Ok() // 24/07/2007
{
DEBUG_LINE
	if (ComboSMTPPort->ItemIndex == 1 && EditAuthMdP->Text == "") // port 587
	{
		ShowMessage("Avec le port 587, le mot de passe ne peut pas tre vide");
		EditAuthMdP->SetFocus();
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
// Fonction de Rappel pour trier les listes de filtres selon Ami, Rejets, Nb de rejets
int __stdcall TriListe(long pItem1, long pItem2, long lParam) // 28/10/2007
{
DEBUG_LINE
int NbRej1, NbRej2;
TListItem *Item1 = (TListItem *)pItem1, *Item2 = (TListItem *)pItem2;
	if (Item1->ImageIndex < Item2->ImageIndex) // Ami = 1 , Rejet = 0
		return 1;
	if (Item1->ImageIndex > Item2->ImageIndex) // Ami = 1 , Rejet = 0
		return -1;
	try
	{
		NbRej1 = StrToInt(Item1->SubItems->Strings[FormRejets->Liste[lParam]->Columns->Count - 3]);
	}
	catch(...)
	{
		NbRej1 = 0;
	}
	try
	{
		NbRej2 = StrToInt(Item2->SubItems->Strings[FormRejets->Liste[lParam]->Columns->Count - 3]);
	}
	catch(...)
	{
		NbRej2 = 0;
	}
	if (NbRej1 < NbRej2)
		return 1;
	if (NbRej1 > NbRej2)
		return -1;
	return 0;
}
//---------------------------------------------------------------------------
// Insertion d'un nouvel item dans ListeHist 20/11/2007
void __fastcall TFormRejets::ListeHistInsert(TObject *Sender, TListItem *Item)
{
DEBUG_LINE
	BtnVideHisto->Enabled = true;
}
//---------------------------------------------------------------------------

