//---------------------------------------------------------------------------
// OutClock : Recensement de boites POP  un intervalle propre
#include <vcl.h>
#pragma hdrstop

#include "OutClock.h"
#include <IniFiles.hpp>

USEFORM("OutClock1.cpp", Form1);
USEFORM("OutClock2.cpp", Form2);
USEFORM("OutClock3.cpp", Form3);
USEFORM("OutClock4.cpp", Apropos);
USEFORM("OutClockRejets.cpp", FormRejets);
USEFORM("OutClock6.cpp", Form6);
USEFORM("OutClock7.cpp", Form7);
USEFORM("OutClock8.cpp", Form8);
USEFORM("OutClockParam.cpp", FParam);
USEFORM("OutClockDemarRTF.cpp", PremierLancement);
USEFORM("OutClockRestaur.cpp", FormRestaur);
USEFORM("OutClockJoker.cpp", FormJoker);
USEFORM("OutClockJokerSaisie.cpp", FormJokerSaisie);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
bool FraEnu = false;
AnsiString OutClockFraEnu[] = {"OutClock.FRA", "OutClock.ENU"};
	for (int i=0 ; i < 2 ; i++)
	{
		if (FileExists(OutClockFraEnu[i]))
		{
			if (!DeleteFile(OutClockFraEnu[i]))
			{
				ShowMessage("Impossible de supprimer l'ancien fichier.\n"
										"Veuillez dtruire manuellement le fichier " + OutClockFraEnu[i] +
										".\nOutClock va tre ferm");
				return 0;
			}
			else
				FraEnu = true;
		}
	}
	if (FraEnu)
	{
		ShowMessage("D'anciens fichiers ont t supprims.\n"
								"OutClock va tre ferm puis relanc");
		ShellExecute(NULL, NULL, Application->ExeName.c_str(), NULL, NULL, SW_SHOWNORMAL);
		return 0;
	}
HANDLE hInstanceMutex;
	TIniFile *ini = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
	bool PlusieursInstances = ini->ReadBool(NOM_APPLI, "PlusieursInstances", false); // 21/05/2006
	delete ini;
	if (!PlusieursInstances)
		hInstanceMutex = ::CreateMutex(NULL, TRUE, NOM_APPLI);
	if(GetLastError() == ERROR_ALREADY_EXISTS)
	{
	char NomClasse[127];
		if(hInstanceMutex)
			CloseHandle(hInstanceMutex);
		Application->Title = "OutClock";
		HWND hPrevApp = FindWindow("TForm1", NOM_APPLI); //*** Form1->Caption NE DOIT JAMAIS ETRE CHANGE
		if (hPrevApp)
			PostMessage(hPrevApp, WM_OUTCLOCK, 0, 0L);
		return 0;
	}
	try
	{
		SetWindowLong(Application->Handle, GWL_EXSTYLE, WS_EX_TOOLWINDOW); // Cacher de la barre des tches
		Application->Initialize();
		Application->Title = NOM_APPLI;
		Application->CreateForm(__classid(TForm1), &Form1);
		Application->CreateForm(__classid(TForm2), &Form2);
		Application->CreateForm(__classid(TForm3), &Form3);
		Application->CreateForm(__classid(TForm6), &Form6);
		Application->CreateForm(__classid(TForm7), &Form7);
		Application->CreateForm(__classid(TForm8), &Form8);
		Application->CreateForm(__classid(TApropos), &Apropos);
		Application->CreateForm(__classid(TFParam), &FParam);
		Application->CreateForm(__classid(TFormRestaur), &FormRestaur);
		Application->CreateForm(__classid(TFormJokerSaisie), &FormJokerSaisie);
		HWND hPrevApp = FindWindow("TForm1", NOM_APPLI); // 07/07/2005
		PostMessage(hPrevApp, WM_OUTCLOCK, 1, 0L); // Pour excution Form1->Lancement 07/07/2005
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	return 0;
}
//---------------------------------------------------------------------------

