//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OutClockParam.h"
#include "OutClock1.h"
#include "OutClockRejets.h"
#include "OutClockRestaur.h"
#include "OutClockJoker.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma link "cspin"
#pragma resource "*.dfm"
TFParam *FParam;
//---------------------------------------------------------------------------
__fastcall TFParam::TFParam(TComponent* Owner) : TForm(Owner)
{
//  Form1->Lancement(); // 19/02/2005 - 08/07/2005
}
//---------------------------------------------------------------------------
// Activate
void __fastcall TFParam::FormActivate(TObject *Sender)
{
DEBUG_LINE
	EditConsonnes->Text = Form1->ListeConsonnes;
	EditAlphaNum->Text = Form1->ListeAlphaNum;
	ChkBoxTestInternet->Checked = Form1->bTestInternet;
	ChkBoxRecenseDemar->Checked = Form1->bRecenseDemar;
	ChkBoxMotDePasse->Checked = Form1->bMotDePasse;
	ChkBoxMsgAmi->Checked = Form1->bMsgAmi;
	ChkBoxAlerteVisu->Checked = Form1->bAlerteVisu;
	ChkBoxHistoSuppr->Checked = Form1->bHistoSuppr;
	ChkBoxVerifVersion->Checked = Form1->bVerifVersion; // 15/07/2007
	CheckBoxAfficheAmis->Checked = Form1->bAfficheAmis; // 12/08/2012
	CSpinEdit1->Value = Form1->iNbSauv; // 10/07/2005
	CSpinEdAttendre->Value =	Form1->DelaiRejeterGarder; // 25/05/2006
	ChkBoxAlarmeSon->Checked = Form1->bAlarmeSon;
	if (RadioGroupLangue->Caption == "&Langue")
		iLangue = 1;
	else
		iLangue = 0;
	RadioGroupLangue->ItemIndex = iLangue;
	Form1->FichierSon2 = Form1->FichierSon;
	LblSonNouvMsg->Caption = ExtractFileName(Form1->FichierSon2);
	Form1->SonRejet2 = Form1->SonRejet;
	LblSonRejet->Caption = ExtractFileName(Form1->SonRejet2);
	Form1->SonAmi2 = Form1->SonAmi;
	LblSonAmi->Caption = ExtractFileName(Form1->SonAmi2);
	Form1->CouleurListes2 = Form1->CouleurListes;
	Shape1->Brush->Color = Form1->CouleurListes2;
	BitBtn3->Enabled = DirectoryExists(LoadStr(3034)); // .\sauv

}
//---------------------------------------------------------------------------
void __fastcall TFParam::ChkBoxMotDePasseClick(TObject *Sender)
{
DEBUG_LINE
	if (ChkBoxMotDePasse->Focused())
  {
		Form1->Protegerparmotdepasse(Sender);
		BitBtn1->SetFocus(); // pour ne pas relancer cette fonction avec la commande ci-dessous
		ChkBoxMotDePasse->Checked = Form1->bMotDePasse;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFParam::Button1Click(TObject *Sender)
{
DEBUG_LINE
	Couleurdeslistes1Click();
	Shape1->Brush->Color = Form1->CouleurListes2;
}
//---------------------------------------------------------------------------
void __fastcall TFParam::Button2Click(TObject *Sender)
{
DEBUG_LINE
	ChoixSon(&Form1->FichierSon2, "FichierSon");
	LblSonNouvMsg->Caption = ExtractFileName(Form1->FichierSon2);
}
//---------------------------------------------------------------------------
void __fastcall TFParam::Button3Click(TObject *Sender)
{
DEBUG_LINE
	ChoixSon(&Form1->SonRejet2, "SonRejet");
	LblSonRejet->Caption = ExtractFileName(Form1->SonRejet2);
}
//---------------------------------------------------------------------------
void __fastcall TFParam::Button4Click(TObject *Sender)
{
DEBUG_LINE
	ChoixSon(&Form1->SonAmi2, "SonAmi");
	LblSonAmi->Caption = ExtractFileName(Form1->SonAmi2);
}
//---------------------------------------------------------------------------
// Ok
void __fastcall TFParam::BitBtn1Click(TObject *Sender)
{
DEBUG_LINE
	Form1->ListeConsonnes = EditConsonnes->Text;
  Form1->ListeAlphaNum = EditAlphaNum->Text;
  Form1->bTestInternet = ChkBoxTestInternet->Checked;
  Form1->bRecenseDemar = ChkBoxRecenseDemar->Checked;
  Form1->bMotDePasse = ChkBoxMotDePasse->Checked;
  Form1->bMsgAmi = ChkBoxMsgAmi->Checked;
	Form1->bAlerteVisu = ChkBoxAlerteVisu->Checked;
	Form1->bHistoSuppr = ChkBoxHistoSuppr->Checked;
	Form1->bVerifVersion = ChkBoxVerifVersion->Checked; // 15/07/2007
	Form1->bAlarmeSon = ChkBoxAlarmeSon->Checked;
	Form1->bAfficheAmis = CheckBoxAfficheAmis->Checked; // 12/08/2012
	Form1->BtnAmi->Down =	Form1->bAfficheAmis;
	Form1->BtnAmi->Hint = LoadStr(1119 + Form1->bAfficheAmis); // 03/03/2013
	Form1->iNbSauv = CSpinEdit1->Value; // 10/07/2005
	Form1->DelaiRejeterGarder = CSpinEdAttendre->Value; // 25/05/2005
	FormRejets->GarderDetruire();
	if (Form1->FichierSon != Form1->FichierSon2)
  {
    Form1->FichierSon = Form1->FichierSon2;
    Form1->ini->WriteString(NOM_APPLI, "FichierSon", Form1->FichierSon);
  }
  if (Form1->SonRejet != Form1->SonRejet2)
  {
    Form1->SonRejet = Form1->SonRejet2;
    Form1->ini->WriteString(NOM_APPLI, "SonRejet", Form1->SonRejet);
  }
	if (Form1->SonAmi != Form1->SonAmi2)
  {
    Form1->SonAmi = Form1->SonAmi2;
    Form1->ini->WriteString(NOM_APPLI, "SonAmi", Form1->SonAmi);
  }
  Form1->CouleurListes = Form1->CouleurListes2;
  Form1->FCouleurListes(Form1->CouleurListes);
  Form1->ini->WriteInteger(NOM_APPLI, "CouleurListes", Form1->CouleurListes);
  if (iLangue != RadioGroupLangue->ItemIndex)
  {
    if (RadioGroupLangue->ItemIndex == 0)
      Form1->Anglais1Click(Sender);
    else
      Form1->Francais1Click(Sender);
  }
  Form1->ListeConsonnesLength = Form1->ListeConsonnes.Length(); // 15/01/2005
  Form1->ListeAlphaNumLength = Form1->ListeAlphaNum.Length(); // 15/01/2005
}
//---------------------------------------------------------------------------
void __fastcall TFParam::ChoixSon(AnsiString *TypeSon, AnsiString CleSon)
{
DEBUG_LINE
	if (*TypeSon == "")
		OpenDialog1->FileName = ExtractFilePath(Forms::Application->ExeName) + LoadStr(1068);
	else
		OpenDialog1->FileName = *TypeSon;
	if (OpenDialog1->Execute())
	{
		if (OpenDialog1->FileName.AnsiPos(LoadStr(1067)))
			OpenDialog1->FileName = "";
		*TypeSon = OpenDialog1->FileName;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFParam::Couleurdeslistes1Click()
{
DEBUG_LINE
	ColorDialog1->Color = Form1->CouleurListes;
	if (ColorDialog1->Execute())
	{
		if (ColorDialog1->Color == clBlack)
			Form1->CouleurListes2 = clWindow;
		else
			Form1->CouleurListes2 = ColorDialog1->Color;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFParam::BitBtn7Click(TObject *Sender)
{
DEBUG_LINE
	Form1->Aide(LoadStr(30007));
}
//---------------------------------------------------------------------------
void __fastcall TFParam::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
DEBUG_LINE
	if (Key == VK_F1)
		BitBtn7Click(Sender);
}
//---------------------------------------------------------------------------
// Restaurer listes de filtres et paramtres 21/01/2008
void __fastcall TFParam::BitBtn3Click(TObject *Sender)
{
	FormRestaur->ShowModal();
}
//---------------------------------------------------------------------------
// Affichag de FormJoker 29/03/2008
void __fastcall TFParam::BitBtn4Click(TObject *Sender)
{
	FormJoker->ShowModal();
}
//---------------------------------------------------------------------------

